/*
 * Copyright (C) 1996,1997,1998,1999
 *	SHUDO Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

/* SIGSEGV Ѥơͭʥ꤫ɤĴ٤ */

#include <stdio.h>	/* for NULL */
#include <signal.h>
#include <setjmp.h>


#define ALWAYS_SIMPLE_HANDLER


/*
 * Global Functions
 */
/* extern void intrInitMD(); */
	/* in javasrc/src/.../java/green_threads/src/interrupt_md.c */


/*
 * Local Functions
 */
#if (defined(SA_SIGINFO) && !defined(ALWAYS_SIMPLE_HANDLER))
static void signalHandlerSegv(int, siginfo_t *, void *);
#else
static void signalHandlerSegv(int);
#endif /* SA_SIGINFO */
static void setSignalHandlerSegv();


/*
 * Local Variables
 */
static struct sigaction sigActOrig;

static jmp_buf env;


/*
 * ͭʥ桼֤ɤĴ٤롣
 */
extern int validateAddress(void *addr) {
  char c;
  int ret;

  setSignalHandlerSegv();

  if (!setjmp(env)) {
    /* touch */
    {
      char c = *((char *)addr);	/* read */
      *((char *)addr) = c;	/* write */
    }

    ret = 1;	/* valid */
  }
  else {
    ret = 0;	/* invalid */
  }

  {
    struct sigaction dummy;
    sigaction(SIGSEGV, &sigActOrig, &dummy);
  }

  return ret;
}


/*
 * Local Functions
 */
#if (defined(SA_SIGINFO) && !defined(ALWAYS_SIMPLE_HANDLER))
static void signalHandlerSegv(int sig, siginfo_t *sip, void *uap)
#else
static void signalHandlerSegv(int sig)
#endif /* SA_SIGINFO */
{
  signal(sig, SIG_IGN);

#if 0
  printf("caught signal: %d\n", sig);
  fflush(stdout);
#endif

  longjmp(env, 1 /* true */);
}


static void setSignalHandlerSegv() {
  struct sigaction sigAct;

#if (defined(SA_SIGINFO) && !defined(ALWAYS_SIMPLE_HANDLER))
  sigAct.sa_handler = NULL;
  sigAct.sa_sigaction = signalHandlerSegv;
#else
  sigAct.sa_handler = signalHandlerSegv;
#endif
  sigemptyset(&(sigAct.sa_mask));
  sigAct.sa_flags = 0;
#ifdef SA_NODEFER
  sigAct.sa_flags |= SA_NODEFER;
#endif
#ifdef SA_RESTART
  sigAct.sa_flags |= SA_RESTART;
#endif
#ifdef SA_SIGINFO
  sigAct.sa_flags &= ~SA_SIGINFO;
#endif
  /*  sigAct.sa_restorer = setSignalHandlerSegv;*/


  sigaction(SIGSEGV, &sigAct, &sigActOrig);
}
