/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.net.Socket;
import java.net.ServerSocket;
import java.io.IOException;
import java.util.Dictionary;
import java.util.Hashtable;
import NET.shudo.moba.lang.PlaceAddress;


/**
 * 饹(饹ե)ž׵ǡ<BR>
 * MobaPlace 鵯ư롣<BR>
 * ġ MobaClassLoader ФClassDistributor ҤȤĤĵư롣
 *
 * @see NET.shudo.moba.place.MobaPlace
 * @see NET.shudo.moba.place.ClassDistributor
 * @see NET.shudo.moba.place.MobaClassLoader
 */
public
class ClassServer implements Runnable {
  private int port;

  private Dictionary classTable = new Hashtable();

  private boolean debug = false;


  public ClassServer(int port, boolean debug) {
    this.port = port + PlaceAddress.CLASS_PORT_DIFF;
    this.debug = debug;
  }
  public ClassServer(boolean debug) {
    this(PlaceAddress.PLACE_PORT, debug);
  }
  public ClassServer(int port) {
    this(port, false);
  }
  public ClassServer() {
    this(false);
  }


  public void run() {
    ServerSocket servsock = null;

    int distributorCount = 0;

    // ³륽åȤ
    try {
      servsock = new ServerSocket(port);
    }
    catch (IOException e) { e.printStackTrace();  System.exit(1); }


    // main loop
    while (true) {
      // accept
      Socket sock = null;

      try {
	sock = servsock.accept();
      }
      catch (IOException e) {
	if (debug)  e.printStackTrace();

	// busy loop 򤱤뤿ǰΤ
	try {  Thread.sleep(2000);  }
	catch (InterruptedException ie) {}

	continue;
      }
      if (debug) {
	System.out.println("ClassServer#run(): accepted.");
	System.out.flush();
      }


      distributorCount++;

      Runnable distributor = null;
      try {
	distributor = new ClassDistributor(sock, classTable, debug);
      }
      catch (IOException e) {
	distributor = null;
	if (debug)  e.printStackTrace();
	continue;
      }
//      Thread t = new Thread(distributor,
//			"Class Distributor " + distributorCount);
//      t.start();
      MobaPlace.threadPool.run(distributor);
    }	// while (true)
  }
}
