/*
 * Copyright (C) 1996,1997,1998
 *	SHUDO Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.net.InetAddress;
import java.net.Socket;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.DataInputStream;
import java.io.PrintStream;
import java.util.StringTokenizer;
import java.util.Enumeration;
import NET.shudo.moba.lang.PlaceAddress;
import java.net.UnknownHostException;
// $B%3%^%s%I5/F0$N$?$a(B
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;


/**
 * $B%3%^%s%I%7%'%k!#D>@\MxMQ<T$+$i$NMW5a$r$5$P$/!#(B<BR>
 * CommandServer $B$+$i5/F0$5$l$k!#(B<BR>
 * $B%3%^%s%I$O(B Command $B%/%i%9$GDj5A$5$l$k!#(B
 *
 * @see NET.shudo.moba.place.CommandServer
 * @see NET.shudo.moba.place.Command
 */
public
class CommandShell implements Runnable {
  private Socket sock = null;
  private boolean debug = false;

  private InputStream sockIn = null;
  private OutputStream sockOut = null;
  private DataInputStream in = null;
  private PrintStream out = null;


  protected CommandShell(Socket sock, boolean debug)
	throws IOException {
    this.sock = sock;
    this.debug = debug;

    // $B%3%^%s%I<u$1IU$1=`Hw(B
    try {
      sockIn = sock.getInputStream();
      sockOut = sock.getOutputStream();
      in = new DataInputStream(sockIn);
      out = new PrintStream(sockOut);
    }
    catch (IOException e) {
      if (debug)  e.printStackTrace();
    }
  }
  protected CommandShell(Socket sock) throws IOException {
    this(sock, false);
  }


  /**
   * $B%3%^%s%I%7%'%k$r=*N;$5$;$k(B
   */
  protected void quit() {
    synchronized (this) {
      doQuit = true;
    }
  }
  private boolean doQuit = false;

  private boolean doIQuit() { return doQuit; }


  public void run() {
    // welcome message
    PlaceAddress here = here = PlaceAddress.localAddress();
    out.println("Welcome to MOBA place on "
	+ here.hostName() + "(" + here.hostAddress() + "):"
	+ here.port() + ".");


    Command commandInstance = Command.getInstance();
    commandInstance.init(this, out, debug);

    while (true) {
      try {
	// prompt
	out.println("Ready.");

	// $B%3%^%s%I<u$1IU$1(B
	String commandLine = in.readLine();

	if (commandLine == null || commandLine.equals(""))  continue;

	// $B2r@O(B
	StringTokenizer tokenizer =
		new StringTokenizer(commandLine, " ,\t\n\r");
	int numToken = tokenizer.countTokens();
	if (numToken <= 0)  continue;
	String[] args = new String[numToken];

	int index = 0;
	while (tokenizer.hasMoreElements()) {
	  args[index++] = (String)tokenizer.nextElement();
	}

	// $BC5:w(B
	Method command = Command.get(args[0]);
	if (command == null) {
	  commandInstance.error("Command " + args[0] + " is not found.");
	  continue;
	}

	// $B5/F0(B
	Object[] invokeArgs = new Object[1];
	invokeArgs[0] = args;
	try {
	  command.invoke(commandInstance, invokeArgs);
	}
	catch (IllegalAccessException e) {
	  // not reached.
	  commandInstance.error("Command \"" + args[0] + "\" is not accessible.");
	}
	catch (IllegalArgumentException e) {
	  // not reached.
	  commandInstance.error("Invocation arguments is illegal.");
	}
	catch (InvocationTargetException e) {
	  commandInstance.error("Command \"" + command.getName() + "\" throws an exception.");
	}
      }
      catch (IOException e) {
	if (debug) {
	  System.out.println("Command shell finishes.");
	}
	break;
      }

      // $B=*N;(B?
      if (doIQuit()) {
	break;
      }
    }	// while (true)


    // $B=*N;(B
    try {
      this.sock.close();
    }
    catch (IOException e) {
      // $BL5;k(B
    }
  }
}
