import java.io.IOException;
import java.net.InetAddress;
import NET.shudo.moba.net.AccessController;


/**
 * AccessController $B%/%i%9$r%F%9%H$9$k!#(B
 */
class ACTest {
  private static final String COMMAND = "java ACTest";

  private void start(String[] args) {
    if (args.length < 2) {
      usage(COMMAND);
      System.exit(1);
    }


    AccessController ac = null;
    InetAddress addr = null;
    String user = null;

    try {
      ac = new AccessController(args[0], true /*debug*/);
      addr = InetAddress.getByName(args[1]);
    }
    catch (IOException e) {
      e.printStackTrace();
    }

    if (args.length >= 3)
      user = args[2];

    boolean result = ac.allow(addr, user);
    System.out.println("result: " + result);
  }


  private static void usage(String cmd) {
    System.out.print("usage: ");
    System.out.print(cmd);
    System.out.println(" access_file hostname [username]");
  }


  public static void main(String[] args) {
    new ACTest().start(args);
  }
}
