/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.tools;

import NET.shudo.moba.reflect.*;


/**
 * ꤵ줿饹Υեɰɽ롣
 * Reflection ѥ饹Ǥ moba.MetaClass Υƥѡ
 */
public
class FieldDumper {
  private void start(String[] argv) {
    MetaClass metaClass = null;
    int nFields;
    int nMethods;

    if (argv.length <= 0) {
      usage();
      System.exit(1);
    }

    for (int j = 0; j < argv.length; j++) {
      try {
	metaClass = MetaClass.get(argv[j]);
      }
      catch (ClassNotFoundException e) {
	System.out.println(e);
	e.printStackTrace();
	System.exit(1);
      }

      System.out.println(metaClass.getName());
      if (metaClass.hasOwnWriteObject())
	System.out.println("  has writeObject()");
      if (metaClass.hasOwnReadObject())
	System.out.println("  has writeObject()");


      nFields = metaClass.fieldCount();
      System.out.println("# of fields: " + nFields);

      for (int i = 0; i < nFields; i++) {
	MetaField mf = null;
	try{
	  mf = metaClass.field(i);
	}
	catch (FieldNotFoundException e) {
	  // not reached
	  e.printStackTrace();  System.exit(1);
	}

	System.out.println(" name:\t" + mf.name());
	System.out.println("  signature:\t" + mf.signature());
	System.out.println("  isArray?:\t" + mf.isArray());
	System.out.println("  isObject?:\t" + mf.isObject());
	System.out.println("  isAccessible?:\t" + mf.isAccessible());
      }


      nMethods = metaClass.methodCount();
      System.out.println("# of methods: " + nFields);

      for (int i = 0; i < nMethods; i++) {
	MetaMethod mm = null;
	try{
	  mm = metaClass.method(i);
	}
	catch (FieldNotFoundException e) {
	  // not reached
	  e.printStackTrace();  System.exit(1);
	}

	System.out.println(" name:\t" + mm.name());
	System.out.println("  signature:\t" + mm.signature());
      }

      System.out.println();	// 
    }
  }

  private void usage() {
    System.out.println(
/*
		"usage:\n\tjava " + this.getClass().getName() +
*/
		"usage:\n\t fielddumper" +
		" classname [classname ...]");
  }

  public static void main(String[] argv) {
    new FieldDumper().start(argv);
  }
}
