/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.tools;


import java.io.FileInputStream;
import java.io.IOException;

import NET.shudo.moba.lang.MobaThread;
import NET.shudo.moba.io.ObjectReader;
import NET.shudo.moba.io.ThreadReader;


/**
 * ꤵ줿ե뤫饹åɤ롣
 */
public
class InternalizeThread {
  private void start(String[] argv) {
    int argc = argv.length;
    MobaThread threads[] = null;
    int i;

    if (argc <= 0) {
      usage();
      System.exit(1);
    }

    threads = new MobaThread[argc];

    for (i = 0; i < argc; i++) {
      ObjectReader in = null;
      try {
	in = new ThreadReader(new FileInputStream(argv[i]));
      }
      catch (IOException e) {
	System.out.println("specified file is not found: " + argv[i]);
	threads[i] = null;
	break;
      }

      // internalize
      try {
	threads[i] = (MobaThread)in.readObject();
      }
      catch (ClassCastException e) {
	System.out.println("file is not externalized thread: " + argv[i]);
	threads[i] = null;
	break;
      }
      catch (Exception e) {
	e.printStackTrace();  System.exit(1);
      }
    }

    // resume all read threads
    for (i = 0; i < argc; i++) {
      if (threads[i] != null)
	threads[i].resume();
    }
  }


  private void usage() {
    System.out.println(
//		"usage:\n\tjava " + this.getClass().getName() +
		"usage:\n\treadthread" +
		" filename [filename ...]");
  }


  public static void main(String[] argv) {
    new InternalizeThread().start(argv);
  }
}
